import { HopperTools } from './tools/hoppers.js';
import { CauldronTools } from './tools/cauldron.js';
import { SoundTools } from "./tools/sounds.js"

const bucket = (block) => {
    const { success, cauldron, outHop, inHop, itemName } = checkStateAndReturnData(block);
    if (success === false) return;

    takeTransactionCost(cauldron, inHop);
    HopperTools.addNonStackableItem(outHop, itemName);
    SoundTools.makeBucketingSound(itemName, block)
}

const checkStateAndReturnData = (block) => {
    getData: {
        const data = { success: true };

        data.cauldron = CauldronTools.getIfFilled(block, "above")
        if (data.cauldron === null) break getData;

        data.inHop = HopperTools.getInputs(block, "minecraft:bucket")[0];
        if (data.inHop == null) break getData;

        data.outHop = HopperTools.getOutput(block);
        if (data.outHop === null || !HopperTools.hasEmptySlot(data.outHop)) break getData;

        data.itemName = CauldronTools.getContentsAsBucketName(data.cauldron);

        return data;
    }

    return { success: false };
}

const takeTransactionCost = (cauldron, inputHopper) => {
    CauldronTools.setFillLevel(cauldron);
    HopperTools.takeItem(inputHopper, "minecraft:bucket");
}

export { bucket }
