class CauldronTools {
    static getState({ permutation }) {
        return permutation.getState("fill_level") === 0 ? "empty" : permutation.getState("cauldron_liquid");
    }

    static setFillLevel(cauldron, fillLevel = 0) {
        cauldron.setPermutation(cauldron.permutation.withState("fill_level", fillLevel));
    }

    static getContentsAsBucketName(cauldron) {
        return `minecraft:${CauldronTools.getState(cauldron)}_bucket`;
    }

    static getIfFilled(block, dir = null) {
        const cauldron = dir === null ? block : block[dir]();

        if (cauldron.typeId != "minecraft:cauldron") return null;
        if (CauldronTools.getState(cauldron) === "empty") return null;

        return cauldron;
    }
}

export { CauldronTools };
